<?php
// Get all categories the current post is tagged with
$catsOfCurrentPost = get_the_category($thispost->ID);
$loadedSopId = 0;
// Find first one with parent=19, i.e. this is the id of the SOP
foreach ($catsOfCurrentPost as $value) {
	if($value->parent == 19) {
		$loadedSopId = $value->term_id;
	}
}

$terms1 = get_terms([
    'taxonomy' => 'category',
    'parent' => 20, // everything below 'beitragstyp'
    'hide_empty' => false
]);

$terms2 = get_terms([
    'taxonomy' => 'category',
    'parent' => 19, // everything below 'sop'
    'hide_empty' => false
]);


// We need all terms as an array [[ID]=>'name']
$beitragstypen = [];
foreach ($terms1 as $term) {
    $id = $term->term_id;
    $name = $term->name;
    $beitragstypen[$id] = $name;
}

// Allow JS to access steps
echo "<script type='text/javascript'>
var allSteps = [];
var openedTab2 = false;
</script>";

$sops = [];
$steps = [];
foreach ($terms2 as $term) {
    $id = $term->term_id;
    $name = $term->name;
    $sops[$id] = $name;
	echo "<script type='text/javascript'>
		allSteps[".$id."] = [];
		</script>";
	$nextSteps = get_terms([
		'taxonomy' => 'category',
		'parent' => $id,
		'hide_empty' => false
	]);
	foreach ($nextSteps as $nextStep) {
		$stepid = $nextStep->term_id;
		$name = $nextStep->name;
		$steps[$id][$stepid] = $name;
		echo "<script type='text/javascript'>
		allSteps[".$id."][".$stepid."] = '".$name."';
		</script>";
	}
}

// Load all titles like 'Bitte Kategorie auswählen' from a json file
$text = file_get_contents("../wordpress/wp-content/plugins/frontier-post/titles.json");
$titles = json_decode($text);

// set initial div including my id shortcode parameter
echo '<div id="frontier-post-form-' . $fpost_sc_parms['frontier_myid'] . '">';


//Display message
frontier_post_output_msg();

if (strlen($fpost_sc_parms['frontier_edit_text_before']) > 1)
    echo '<div id="frontier_edit_text_before">' . $fpost_sc_parms['frontier_edit_text_before'] . '</div>';


//***************************************************************************************
//* Start form
//***************************************************************************************


echo '<div class="frontier_post_form"> ';
echo '<form action="' . $frontier_permalink . '" method="post" name="frontier_post" id="frontier_post" enctype="multipart/form-data" >';

// do not remove this include, as it holds the hidden fields necessary for the logic to work
include(FRONTIER_POST_DIR . "/forms/frontier_post_form_header.php");

wp_nonce_field('frontier_add_edit_post', 'frontier_add_edit_post_' . $thispost->ID);

?>

    <!------------------------------ jQuery------------------------------------------->

	<script src="../wp-content/themes/twentytwenty-Child/templates/js/jquery.min.js"></script>

	<!--<script src="https://cdnjs.cloudflare.com/ajax/libs/jquery/3.4.1/jquery.min.js">
	</script>-->

	<!------------------------------ Heic2any------------------------------------------->

	<script src="../wp-content/themes/twentytwenty-Child/templates/js/heic2any.js"></script>

	<!------------------------------ TABS------------------------------------------->

    <div id="tabs1" class="tab">
        <button id= "topic1" class="tablinks" onclick="openTabs(event, 'Topic')" style="font-size:16px">1. Thema</button>
        <button id= "content1" class="tablinks" onclick="openTabs(event, 'Content'); copytocontent();" style="font-size:16px">2. Inhalt</button>
        <button id= "check1" class="tablinks" onclick="openTabs(event, 'Check'); copytowpeditor();" style="font-size:16px">3. Zusammenfassung</button> 
    </div>

    <script>
        // Get the element with id="defaultOpenTab" and click on it
        //document.getElementById("defaultOpenTab").click();
       //$('defaultOpenTab').click();
        window.onload = function() {
			
			document.getElementById("topic1").click(); 
			// "Losing focus on input field" 
			document.getElementById("topic1").click();
			
		}
		
		//Select only one item for the categories
		$(document).ready(function(){		
			$("#fp_tax_category_1").removeAttr('multiple');
			$('#fp_tax_category_2').removeAttr('multiple');

			$('#fp_tax_step_1').removeAttr('multiple');
			$('#fp_tax_step_2').removeAttr('multiple');

			$('#fp_tax_type_1').removeAttr('multiple');
			$('#fp_tax_type_2').removeAttr('multiple');
		});
		
		// Matomo adding 'data-matomo-unmask' to tags
		
		function datamatomounmask(){
		
			var i=0;
			
			var xselect = document.getElementsByTagName("select");
			var xinput = document.getElementsByTagName("input");
			var xtextarea = document.getElementsByTagName("textarea");
			
			// WPEditor
			var xwpeditor = document.getElementById("frontier_post_content");
			
			// Canvas
			/*var xcanvascd = document.getElementsByName('canvas-container-div');
			var xcanvasc = document.getElementsByClassName('canvas-container');
			var xlowcanvas = document.getElementsByClassName("lower-canvas");
			var xupcanvas = document.getElementsByClassName("upper-canvas");*/

			var dmu = "data-matomo-unmask";

			for (i = 0; i < xselect.length; i++) {
			  xselect[i].setAttribute(dmu, dmu);
				} 

			for (i = 0 ; i < xinput.length; i++) {
			  xinput[i].setAttribute(dmu, dmu);
				}

			for (i = 0; i < xtextarea.length; i++) {
			  xtextarea[i].setAttribute(dmu, dmu);
				}
			
			// WPEditor
			for (i = 0; i < xwpeditor.length; i++) {
			  xwpeditor[i].setAttribute(dmu, dmu);
				}
			
			//Canvas
			/*for (i = 0; i < xcanvascd.length; i++) {
			  xcanvascd[i].setAttribute(dmu, dmu);
				}
			for (i = 0; i < xcanvasc.length; i++) {
			  xcanvasc[i].setAttribute(dmu, dmu);
				}
			for (i = 0; i < xlowcanvas.length; i++) {
			  xlowcanvas[i].setAttribute(dmu, dmu);
				}
			for (i = 0; i < xupcanvas.length; i++) {
			  xupcanvas[i].setAttribute(dmu, dmu);
				}*/
		
		}
		
		// ------------------------------------------
		
		
		//Disabling backspace
		$(function(){
			/*
			 * this swallows backspace keys on any non-input element.
			 * stops backspace -> back
			 */
			var rx = /INPUT|SELECT|TEXTAREA/i;

			$(document).bind("keydown keypress", function(e){
				if( e.which == 8 ){ // 8 == backspace
					if(!rx.test(e.target.tagName) || e.target.disabled || e.target.readOnly ){
						e.preventDefault();
					}
				}
			});
		});
		
        function openTabs(evt, tabName) {
			
			datamatomounmask();
			
			// Jump to top of the browser page
			$('html,body').scrollTop(0);
			
			//Synchronize tabs that are active
			var tb1 = document.getElementById("tabs1");
			var tb2 = document.getElementById("tabs2");
			
			var top1 = document.getElementById("topic1");
			var top2 = document.getElementById("topic2");
			var cont1 = document.getElementById("content1");
			var cont2 = document.getElementById("content2");
			var che1 = document.getElementById("check1");
			var che2 = document.getElementById("check2");
			
			// Setzt Topic2 Reiter ebenfalls auf active bei Default
			top2.classList.add("active");
			
			tb1.addEventListener("click", function() {
				if (top1.classList.contains("active")) {
					top2.classList.add("active");
					
					cont1.classList.remove("active");
					cont2.classList.remove("active");
					che1.classList.remove("active");
					che2.classList.remove("active");
					
				} 
				
				if (cont1.classList.contains("active")){
					cont2.classList.add("active");
					
					top1.classList.remove("active");
					top2.classList.remove("active");
					che1.classList.remove("active");
					che2.classList.remove("active");
				}
				
				if (che1.classList.contains("active")){
					che2.classList.add("active");
					
					top1.classList.remove("active");
					top2.classList.remove("active");
					cont1.classList.remove("active");
					cont2.classList.remove("active");
				}
				
				else {}
			});
			
			tb2.addEventListener("click", function() {
				
				if (top2.classList.contains("active")) {
					top1.classList.add("active");
					
					cont1.classList.remove("active");
					cont2.classList.remove("active");
					che1.classList.remove("active");
					che2.classList.remove("active");
				} 
				
				if (cont2.classList.contains("active")){
					cont1.classList.add("active");
					
					top1.classList.remove("active");
					top2.classList.remove("active");
					che1.classList.remove("active");
					che2.classList.remove("active");
				}
				
				if (che2.classList.contains("active")){
					che1.classList.add("active");
					
					top1.classList.remove("active");
					top2.classList.remove("active");
					cont1.classList.remove("active");
					cont2.classList.remove("active");
				}
				
				else {}
			});
			
			//console.log('Test');
			// Declare all variables
            var i, tabcontent, tablinks;

            // Get all elements with class="tabcontent" and hide them
            tabcontent = document.getElementsByClassName("tabcontent");
            for (i = 0; i < tabcontent.length; i++) {
                tabcontent[i].style.display = "none";
            }

            // Get all elements with class="tablinks" and remove the class "active"
            tablinks = document.getElementsByClassName("tablinks");
            for (i = 0; i < tablinks.length; i++) {
                tablinks[i].className = tablinks[i].className.replace(" active", "");
            }

            // Show the current tab, and add an "active" class to the button that opened the tab
            document.getElementById(tabName).style.display = "block";
            evt.currentTarget.className += " active";
        }
		

		// Convert to image and upload it to WordPress library without downloading 
		function sendtowordpress(){
			
			//dataUrl = canvas.toDataURL("image/png");
			
			//-------- Base64toDataURL
			
			dataUrl = dataUrl.replace(/^data:image\/(png|jpg|jpeg|heic|heif);base64,/, "");
			$.post("send.php?data="+dataUrl);

			//--------
		
		}
		
		function copytocontent(){
			openedTab2 = true; 
			var $iframe = $('#frontier_post_content_ifr');
			$iframe.ready(function() {
				
			var n = 1;
			
			contentx = 	$iframe.contents().find(".completecontent");
			console.log(contentx);	
			
			var localCanvas = new Array();
			var imgObj = new Array();
			var context = new Array();	
			var imgPath = new Array();
				
			for(var content of contentx)
				{
					
		    var setImage = function(n) {
			//When our image has loaded.
			imgObj[n-1].onload = function(){
   			console.log("Wird geladen!");
				
				var activeCanvas = canvas[n-1];
					console.log('Active canvas copytocontent: ',  activeCanvas);
					var image = new fabric.Image(imgObj[n-1]);
						image.set({
							angle: 0,
							padding: 0,
							cornersize: 10,
						});
					
					//image.scaleToWidth(activeCanvas.getWidth()); //512
					//image.style.maxWidth = "512px"; 
					//image.style.width = "410px";
					//image.style.maxHeight = "412px";

					function getSafe(fn, defaultVal) {
						try {
								return fn();
							} 
						catch (e) {
								return defaultVal;
							}
						}

					getSafe(() => image.style.width = "512px");
					
					activeCanvas.clear();
					activeCanvas.centerObject(image);
					activeCanvas.add(image);
					activeCanvas.renderAll();
				
			}
			
			//Set the src of this Image object.
			imgObj[n-1].src = imgPath[n-1];
		    }
					console.log(content);
					
					// Rauskopieren aus dem completecontent
					
					content.removeChild(content.firstChild);
					
					var text = content.textContent;
					console.log(text);
					
					var img = $iframe.contents().find("#imgData" + (n-1));
					console.log('Debug: ' + JSON.stringify(img));
					var bildquelle = '';
					var bildbreite = 0;
					if (img.length > 0) {
						bildquelle = img[0].src;
						bildbreite = img[0].width;
						console.log('Debug: Breite ' + bildbreite);
					}
					
					// Reinkopieren in content
					
					document.getElementById('t' + (n-1)).value = text;
					
					localCanvas[n-1] = document.getElementById('c' + (n-1));
					
					//Get a 2D drawing context for the canvas.
					context[n-1] = localCanvas[n-1].getContext('2d');
					//The path to the image that we want to add.
					imgPath[n-1] = bildquelle;
					//Create a new Image object.
					imgObj[n-1] = new Image();
					//the x coordinates
					var x = 0;
					//the y coordinates
					var y = 0;
					setImage(n);
					
					if(n < contentx.length){
					    if (n >= document.getElementsByClassName('duplicationContent').length)	{
						    createNewStep(); 
						}
						n++
					   }
					
				}
				
			});
		}
			
		function copytowpeditor(){
			if (openedTab2 == false)
				return null;
			
			var $iframe = $('#frontier_post_content_ifr');
			$iframe.ready(function() {
			
		    $iframe.contents().find("body").html("");
				
			var i = 0;
				
			while(document.getElementById('t'+[i])!= null)
				{

					var activeCanvas = canvas[i];
					activeCanvas.isDrawingMode = true;
					activeCanvas.discardActiveObject();
					activeCanvas.renderAll();
					
					var para = document.createElement("p");
					var img = document.createElement("img");
					img.id = "imgData"+i;
					
					var header = document.createElement("h4");
					header.innerHTML = document.getElementsByName('step_legend')[i].innerHTML + ":" + "<br />" + "<br />";
					para.innerHTML = document.getElementById('t'+[i]).value + "<br />" + "<br />";
					
					var canvasmod = document.getElementById('c'+i);
					
					//img.style.maxWidth = "512px";
					//img.style.width = "512px";
					//img.style.width = "410px";
					//img.style.maxHeight = "412px";
					//if(typeof img != "undefined"){ 
					// Do something here; 
					//}
					
					function getSafe(fn, defaultVal) {
						try {
								return fn();
							} 
						catch (e) {
								return defaultVal;
							}
						}

					getSafe(() => img.style.width = "512px");
					
					img.src = canvasmod.toDataURL('png');
					
					// TESTING
					//para.innerHTML = ('GROßES TESTEN:' + img.src);
					
					var completecontent = document.createElement("div");
					console.log('Debug: Create complete content ' + i);
					completecontent.classList.add("completecontent");
					completecontent.appendChild(header); 
					completecontent.appendChild(para);
					if (!isCanvasBlank(activeCanvas)) {
						console.log('Debug: Ein Bild ist vorhanden');
						completecontent.appendChild(img);
					}
					$iframe.contents().find("body").append(completecontent);
					
					i++;
				}
			});
		}
		
		function isCanvasBlank(canvas) {
			return !canvas.getContext('2d')
				.getImageData(0, 0, canvas.width, canvas.height).data
				.some(channel => channel !== 0);
		}

    </script>


    <!------------------------------------- POSTING 1. TOPIC ------------------------------------->

    <div id="Topic" class="tabcontent" style="overflow:auto">
        <!-- <span onclick="this.parentElement.style.display='none'">x</span> -->

        <?php
		echo '<br /><legend class="explaintextbox" style="font-style: italic;">Für die Erstellung eines neuen Lerninhalts folgen Sie bitte den aufgeführten Arbeitsanweisungen.</legend><br /><br />';
        
		//**********************************************************************************
        //* Taxonomies
        //**********************************************************************************

        //$tax_list = array("category", "group", "article-type");
        $tax_list = $fpost_sc_parms['frontier_custom_tax'];
        $tax_layout_list = fp_get_tax_layout($fpost_sc_parms['frontier_custom_tax'], $fpost_sc_parms['frontier_custom_tax_layout']);

        echo '<tr><td class="frontier_no_border">';
        #var_dump($tax_form_lists["category"]);

        foreach ($tax_layout_list as $tmp_tax_name => $tmp_tax_layout) {
            if ($tmp_tax_layout != "hide") {
                // Cats_selected is set from script, but only for category
                if ($tmp_tax_name != 'category')
                    $cats_selected = wp_get_post_terms($thispost->ID, '$tmp_tax_name', array("fields" => "ids"));

                echo '<fieldset class="frontier_post_fieldset_tax frontier_post_fieldset_tax_' . $tmp_tax_name . '">';
                echo '<legend class="frontier_post_legend_tax" >' . $titles->sops . '</legend>';

                //****************************************************************************************************
                // Action fires before displaying taxonomies
                // Do action 		frontier_post_form_standard_top
                // $thispost 		Post object for the post
                // $tmp_task_new  	Equals true if the user is adding a post
                // $tmp_tax_name	Name of Taxonomy (ex Category")
                //****************************************************************************************************


                do_action('frontier_post_form_standard_tax', $thispost, $tmp_task_new, $tmp_tax_name);
                frontier_tax_input($thispost->ID, 'category_1', $tmp_tax_layout, $cats_selected, $fpost_sc_parms, $sops);
                echo '</fieldset><br />';
                echo PHP_EOL;
            }
        }
		// After creating the SOP list, add an on-click event to it:
		// Each time when a SOP is selected, change the options available in the sop-steps dropdown
		echo "<script type='text/javascript'>
			var sopDropDown = document.getElementById('fp_tax_category_1');
			sopDropDown.onchange = function() {
				var stepDropDown1 = document.getElementById('fp_tax_step_1');
				var stepDropDown2 = document.getElementById('fp_tax_step_2');
				var sopId = sopDropDown.options[sopDropDown.selectedIndex].value;
				var noSteps = stepDropDown1.options.length; 
				for (var i = 0; i < noSteps; i++) {
					stepDropDown1.options[0] = null;
					stepDropDown2.options[0] = null;
				}
				Object.keys(allSteps[sopId]).forEach(function(k){
					var option = document.createElement('option');
        			option.text = allSteps[sopId][k];
					option.classList.add('fp_multi');
					<!--option.classList.add('fp_dropdown'); -->
					option.value = k;
					var option2 = option.cloneNode(true);
					stepDropDown1.add(option);
        			stepDropDown2.add(option2);
        		});
				syncList(1);
	    }
		</script>";

		//****************************************************************************************************
        // tags
        //****************************************************************************************************
		
		if (current_user_can('frontier_post_tags_edit') || fp_get_option("fps_show_feat_img", "false") !== "false") {

            if (current_user_can('frontier_post_tags_edit')) {
                echo '<fieldset class="frontier_post_fieldset_tax frontier_post_fieldset_tax_tag">';
                echo '<legend>' . __("Tags", "frontier-post") . '</legend>';
                for ($i = 0; $i < $fp_tag_count; $i++) {
                    $tmp_tag = isset($taglist[$i]) ? fp_tag_transform($taglist[$i]) : "";
                    //$tmp_tag = array_key_exists($i, $taglist) ? fp_tag_transform($taglist[$i]) : "";
                    echo '<input placeholder="' . __("Enter tag here", "frontier-post") . '" type="text" value="' . $tmp_tag . '" name="user_post_tag_1' . $i . '" id="user_post_tag_1' . $i . '"><br>';
                }
                echo '</fieldset><br />';
            }

        } 
		
		// end tags and featured image

        if (current_user_can('frontier_post_exerpt_edit')) { ?>
            <fieldset class="frontier_post_fieldset_excerpt">
                <legend><?php _e("Excerpt", "frontier-post") ?>:</legend>
                <textarea name="user_post_excerpt_1"
                          id="user_post_excerpt_1"><?php if (!empty($thispost->post_excerpt)) echo $thispost->post_excerpt; ?></textarea>
            </fieldset>

        <?php }

        echo '</td></tr>';
		
		/* **********************Create selector dropdown for SOP step******************************************************
		 * *****************************************************************************************************************
		 */
		echo '<tr><td class="frontier_no_border">';
        #var_dump($tax_form_lists["category"]);

        foreach ($tax_layout_list as $tmp_tax_name => $tmp_tax_layout) {
            if ($tmp_tax_layout != "hide") {
                // Cats_selected is set from script, but only for category
                if ($tmp_tax_name != 'category')
                    $cats_selected = wp_get_post_terms($thispost->ID, '$tmp_tax_name', array("fields" => "ids"));

                echo '<fieldset class="frontier_post_fieldset_tax frontier_post_fieldset_tax_' . $tmp_tax_name . '">';
                echo '<legend class="frontier_post_legend_tax" >' . $titles->steps . '</legend>';

                //****************************************************************************************************
                // Action fires before displaying taxonomies
                // Do action 		frontier_post_form_standard_top
                // $thispost 		Post object for the post
                // $tmp_task_new  	Equals true if the user is adding a post
                // $tmp_tax_name	Name of Taxonomy (ex Category")
                //****************************************************************************************************


                do_action('frontier_post_form_standard_tax', $thispost, $tmp_task_new, $tmp_tax_name);
                frontier_tax_input($thispost->ID, 'step_1', $tmp_tax_layout, $cats_selected, $fpost_sc_parms, $steps[$loadedSopId]);
				echo "<script type='text/javascript'>
				var sl3 = document.querySelector('#fp_tax_step_1');
				sl3.onchange = function() {syncList(3)};
				</script>";
                echo '</fieldset>';
                echo PHP_EOL;
            }
        }

        //****************************************************************************************************
        // tags
        //****************************************************************************************************
		
		if (current_user_can('frontier_post_tags_edit') || fp_get_option("fps_show_feat_img", "false") !== "false") {

            if (current_user_can('frontier_post_tags_edit')) {
                echo '<fieldset class="frontier_post_fieldset_tax frontier_post_fieldset_tax_tag">';
                echo '<legend>' . __("Tags", "frontier-post") . '</legend>';
                for ($i = 0; $i < $fp_tag_count; $i++) {
                    $tmp_tag = isset($taglist[$i]) ? fp_tag_transform($taglist[$i]) : "";
                    //$tmp_tag = array_key_exists($i, $taglist) ? fp_tag_transform($taglist[$i]) : "";
                    echo '<input placeholder="' . __("Enter tag here", "frontier-post") . '" type="text" value="' . $tmp_tag . '" name="user_post_tag_2' . $i . '" id="user_post_tag_2' . $i . '"><br>';
                }
                echo '</fieldset>';
            }

        } 
		
		// end tags and featured image

        if (current_user_can('frontier_post_exerpt_edit')) { ?>
            <fieldset class="frontier_post_fieldset_excerpt">
                <legend><?php _e("Excerpt", "frontier-post") ?>:</legend>
                <textarea name="user_post_excerpt_2"
                          id="user_post_excerpt_2"><?php if (!empty($thispost->post_excerpt)) echo $thispost->post_excerpt; ?></textarea>
            </fieldset>

        <?php }

        echo '</td></tr>';
		

        echo '<tr><td class="frontier_no_border">';
        #var_dump($tax_form_lists["category"]);

        foreach ($tax_layout_list as $tmp_tax_name => $tmp_tax_layout) {
            if ($tmp_tax_layout != "hide") {
                // Cats_selected is set from script, but only for category
                if ($tmp_tax_name != 'category')
                    $cats_selected = wp_get_post_terms($thispost->ID, '$tmp_tax_name', array("fields" => "ids"));

                echo '<fieldset class="frontier_post_fieldset_tax frontier_post_fieldset_tax_' . $tmp_tax_name . '">';
                echo '<legend class="frontier_post_legend_tax" >' . $titles->types . '</legend>';

                //****************************************************************************************************
                // Action fires before displaying taxonomies
                // Do action 		frontier_post_form_standard_top
                // $thispost 		Post object for the post
                // $tmp_task_new  	Equals true if the user is adding a post
                // $tmp_tax_name	Name of Taxonomy (ex Category")
                //****************************************************************************************************


                do_action('frontier_post_form_standard_tax', $thispost, $tmp_task_new, $tmp_tax_name);
                frontier_tax_input($thispost->ID, 'type_1', $tmp_tax_layout, $cats_selected, $fpost_sc_parms, $beitragstypen);
				echo "<script type='text/javascript'>
					var sl5 = document.getElementById('fp_tax_type_1');
					sl5.onchange = function() {
						syncList(5);
				}
				</script>";
                echo '</fieldset>';
                echo PHP_EOL;
            }
        }


		//****************************************************************************************************
        // tags
        //****************************************************************************************************
		
        if (current_user_can('frontier_post_tags_edit') || fp_get_option("fps_show_feat_img", "false") !== "false") {

            if (current_user_can('frontier_post_tags_edit')) {
                echo '<fieldset class="frontier_post_fieldset_tax frontier_post_fieldset_tax_tag">';
                echo '<legend>' . __("Tags", "frontier-post") . '</legend>';
                for ($i = 0; $i < $fp_tag_count; $i++) {
                    $tmp_tag = isset($taglist[$i]) ? fp_tag_transform($taglist[$i]) : "";
                    //$tmp_tag = array_key_exists($i, $taglist) ? fp_tag_transform($taglist[$i]) : "";
                    echo '<input placeholder="' . __("Enter tag here", "frontier-post") . '" type="text" value="' . $tmp_tag . '" name="user_post_tag_3' . $i . '" id="user_post_tag_3' . $i . '"><br>';
                }
                echo '</fieldset>';
            }

        } 
		
		// end tags and featured image

        if (current_user_can('frontier_post_exerpt_edit')) { ?>
            <fieldset class="frontier_post_fieldset_excerpt">
                <legend><?php _e("Excerpt", "frontier-post") ?>:</legend>
                <textarea name="user_post_excerpt_3"
                          id="user_post_excerpt_3"><?php if (!empty($thispost->post_excerpt)) echo $thispost->post_excerpt; ?></textarea>
            </fieldset>

        <?php }

        echo '</td></tr>';
        ?>

        <tr>
            <td class="frontier_no_border">

                <?php
                if (fp_get_option_bool("fps_title_required"))
                    $fp_title_required = "REQUIRED";
                else
                    $fp_title_required = "";

                ?>
				
				<fieldset id="frontier_post_fieldset_title" class="frontier_post_fieldset" style="display: none;">
                    
					<legend><?php echo $titles->title; ?></legend>
                    <input id="title-original" class="frontier-formtitle" <?php echo $fp_title_required; ?>
                           placeholder="<?php _e('Enter title here', 'frontier-post'); ?>" type="text"
                           value=""
                           name="user_post_title" id="fp_title" novalidate>
                </fieldset>
				
				<fieldset id="frontier_post_fieldset_title_fake" class="frontier_post_fieldset">
					<legend><?php echo $titles->title; ?></legend>
                    <input id="title_fake1" class="frontier-formtitle title-input" <?php echo $fp_title_required; ?>
                           placeholder="<?php _e('Enter title here', 'frontier-post'); ?>" type="text"
                           value="<?php if (!empty($thispost->post_title)) echo $thispost->post_title; ?>"
                           name="user_post_title" id="fp_title" novalidate>
                </fieldset>
				
				<br /><legend class="explaintextbox" style="font-style: italic;">Klicken Sie auf "2. Inhalt" um mit der Beschreibung notwendiger Arbeitsschritte fortzufahren.</legend><br />
		
            </td>
        </tr>

    </div>

<?php
//****************************************************************************************************
// Action fires before displaying the editor
// Do action 		frontier_post_form_standard_top
// $thispost 		Post object for the post
// $tmp_task_new  	Equals true if the user is adding a post
//****************************************************************************************************

do_action('frontier_post_form_standard_top', $thispost, $tmp_task_new);
?>

    <!------------------------------------- POSTING 2. CONTENT ------------------------------------->


    <div id="Content" class="tabcontent">

		<br /><legend class="explaintextbox" style="font-style: italic;">A) Formulieren Sie eine kurze Beschreibung für einen der notwendigen Arbeitsschritte. <br><br>	
B) Erstellen Sie Bildmaterial, welches den Arbeitsschritt abbildet, und fügen Sie es ein. 
</legend>
		
        <div class="duplicationContent">
            <tr>
                <td class="frontier_no_border">
                    <fieldset class="frontier_post_fieldset">
						<legend></legend><br>
						<legend name='step_legend'>Schritt 1</legend>
                        <legend><?php echo $titles->content; ?></legend>
                    </fieldset>
                </td>
            </tr>
				
			<fieldset id="textarea-fieldset-custom" class="frontier_post_fieldset">
				<legend>
					<textarea id="t0" rows="4" cols="50" style="width:512px"></textarea>
				</legend>
            </fieldset>

			<br /><br />
			
<!--------------------------------- TESTING Frontier-freedrawing --------------------------------->
    
	<legend>
	
		<legend class="frontier_post_legend_tax"> Erstellen Sie Bildmaterial, welches den Arbeitsschritt abbildet, und fügen Sie es ein.</legend>
		
		<!-- Fontawesome -->
		
		<link rel="stylesheet" href="https://use.fontawesome.com/releases/v5.7.2/css/all.css" />
		
		<!-- <link rel="stylesheet" href="../wp-content/themes/twentytwenty-Child/templates/css/all.css" /> -->
        
		<!-- Fabric JS -->
		
		<!-- <script src="https://cdnjs.cloudflare.com/ajax/libs/fabric.js/3.6.1/fabric.min.js"></script> -->
		
	<!--	<script src="https://cdnjs.cloudflare.com/ajax/libs/fabric.js/4.1.0/fabric.min.js"></script> -->

<script src="../wp-content/themes/twentytwenty-Child/templates/js/fabric.min.js"></script>		
		
		<!-- HISTORY -->
		<script>
					/**
			 * Override the initialize function for the _historyInit();
			 */
			fabric.Canvas.prototype.initialize = (function(originalFn) {
			  return function(...args) {
				originalFn.call(this, ...args);
				this._historyInit();
				return this;
			  };
			})(fabric.Canvas.prototype.initialize);

			/**
			 * Override the dispose function for the _historyDispose();
			 */
			fabric.Canvas.prototype.dispose = (function(originalFn) {
			  return function(...args) {
				originalFn.call(this, ...args);
				this._historyDispose();
				return this;
			  };
			})(fabric.Canvas.prototype.dispose);

			/**
			 * Returns current state of the string of the canvas
			 */
			fabric.Canvas.prototype._historyNext = function () {
			  return JSON.stringify(this.toDatalessJSON(this.extraProps));
			}

			/**
			 * Returns an object with fabricjs event mappings
			 */
			fabric.Canvas.prototype._historyEvents = function() {
			  return {
				'object:rotated':this._historySaveAction, 
				'object:rotating':this._historySaveAction, 
				'object:added': this._historySaveAction,
				'object:removed': this._historySaveAction,
				'object:modified': this._historySaveAction,
				'object:skewing': this._historySaveAction,
                'object:scaled': this._historySaveAction,
                'object:moved': this._historySaveAction,
                'object:skewed': this._historySaveAction,
                'object:scaling': this._historySaveAction,
                'object:moving': this._historySaveAction
			  }
			}

			/**
			 * Initialization of the plugin
			 */
			fabric.Canvas.prototype._historyInit = function () {
			  this.historyUndo = [];
			  this.historyRedo = [];
			  this.extraProps = ['selectable'];
			  this.historyNextState = this._historyNext();

			  this.on(this._historyEvents());
			}

			/**
			 * Remove the custom event listeners
			 */
			fabric.Canvas.prototype._historyDispose = function () {
			  this.off(this._historyEvents())
			}

			/**
			 * It pushes the state of the canvas into history stack
			 */
			fabric.Canvas.prototype._historySaveAction = function () {

			  if (this.historyProcessing)
				return;

			  const json = this.historyNextState;
			  this.historyUndo.push(json);
			  this.historyNextState = this._historyNext();
			  this.fire('history:append', { json: json });
			}

			/**
			 * Undo to latest history. 
			 * Pop the latest state of the history. Re-render.
			 * Also, pushes into redo history.
			 */
			fabric.Canvas.prototype.undo = function (callback) {
			  // The undo process will render the new states of the objects
			  // Therefore, object:added and object:modified events will triggered again
			  // To ignore those events, we are setting a flag.
			  this.historyProcessing = true;

			  const history = this.historyUndo.pop();
			  if (history) {
				// Push the current state to the redo history
				this.historyRedo.push(this._historyNext());
				this.historyNextState = history;
				this._loadHistory(history, 'history:undo', callback);
			  } else {
				this.historyProcessing = false;
			  }
			}

			/**
			 * Redo to latest undo history.
			 */
			fabric.Canvas.prototype.redo = function (callback) {
			  // The undo process will render the new states of the objects
			  // Therefore, object:added and object:modified events will triggered again
			  // To ignore those events, we are setting a flag.
			  this.historyProcessing = true;
			  const history = this.historyRedo.pop();
			  if (history) {
				// Every redo action is actually a new action to the undo history
				this.historyUndo.push(this._historyNext());
				this.historyNextState = history;
				this._loadHistory(history, 'history:redo', callback);
			  } else {
				this.historyProcessing = false;
			  }
			}

			fabric.Canvas.prototype._loadHistory = function(history, event, callback) {
			  var that = this;

			  this.loadFromJSON(history, function() {
				that.renderAll();
				that.fire(event);
				that.historyProcessing = false;

				if (callback && typeof callback === 'function')
				  callback();
			  });
			}

			/**
			 * Clear undo and redo history stacks
			 */
			fabric.Canvas.prototype.clearHistory = function() {
			  this.historyUndo = [];
			  this.historyRedo = [];
			  this.fire('history:clear');
			}

			/**
			 * Off the history
			 */
			fabric.Canvas.prototype.offHistory = function() {
			  this.historyProcessing = true;
			}

			/**
			 * On the history
			 */
			fabric.Canvas.prototype.onHistory = function() {
			  this.historyProcessing = false;

			  this._historySaveAction();
			}
			
		</script>

		<ol style="font-size: 16px">
			</br>
		<p>Für die Zeichenumgebung können sie folgende Werkzeuge nutzen:</p>

		<details>
        <summary id="summaryworktools" style="text-align: justify;"> &nbsp; <i class="fas fa-info-circle" ></i> &nbsp; Werkzeuge anzeigen </summary>
		<br />
		<ol><i class="fas fa-mouse-pointer" ></i> Mit dem Cursor können Sie Elemente auswählen und verschieben.</ol>
		<ol><i class="fas fa-pencil-alt" ></i> Mit dem Stift können Sie auf dem Bild zeichnen.</ol>
		<ol><i class="fas fa-cube"></i> Sie können Formen per Drag-and-Drop in Ihr Bild integrieren.</ol> 
		<ol><i class="fas fa-text-width"></i> Sie können dem Bild Texte hinzufügen.</ol>
		<ol><i class="fas fa-trash-alt"></i> Mit dem Mülleimer können Sie markierte Objekte löschen.</ol>
		<ol><i class="fas fa-arrow-circle-left" ></i> Mit dem Pfeil nach links können Sie das Bild um 90 Grad nach links drehen</ol>
		<ol><i class="fas fa-arrow-circle-right" ></i> Mit dem Pfeil nach rechts können Sie das Bild um 90 Grad nach rechts drehen</ol>
		<ol><i class="fas fa-undo" ></i> Sie können beliebig viele Schritte rückgängig machen</ol>
		<ol><i class="fas fa-upload"></i> Sie können zudem ein Bild hochladen und darauf zeichnen</ol>
		</ol>
		
		</details>
			
		<div class="w3-row">

			<div onclick="handleTabChange(this)" id="cc0" name="canvas-container-div" style="width: 512px; height: 412px; position: relative; user-select: none; float: left; margin: 10px;">
			
				<canvas id="c0" width="512" height="412"
					style="border: 1px solid rgb(170, 170, 170); position: absolute; width: 512px; height: 412px; left: 0px; top: 0px; touch-action: none; user-select: none;">
				</canvas>
			
			</div>

			<div id="tool-container" style="border: 1px solid rgb(170, 170, 170); width: 512px; height: 240px; margin: 10px; padding: 5px 5px 0px 5px; position: relative; user-select: none; float: left;">
				<div class="w3-row">
					<p></p>
					<div class="w3-col s6">
						<center> 
						<i class="fas fa-upload" style="color:grey;"></i>&nbsp;
						 <!-- <h:form id="imgUpload0" class="mod00" enctype="multipart/form-data"> 
						<h:form id="imgUploadForm0" class="mod00" enctype="multipart/form-data"> -->
							<input type="file" id="imgUpload0" class="mod01"
								accept="image/*" />
						<!--</h:form>-->
						</center>
					</div>
					
					<div id="tools" class="w3-col s6">
						<center> 
						<button id="st0" class="btn mod1" style="background-color:#00af88" title="Elemente auswählen und verschieben"><i class="fas fa-mouse-pointer" ></i></button>
						<button id="et0" class="btn mod2" style="background-color:#00af88" title="Auf dem Bild zeichnen"><i class="fas fa-pencil-alt" ></i></button>
						<button id="it0" class="btn mod2b" style="background-color:#00af88" title="Formen hinzufügen"><i class="fas fa-cube" ></i></button>
						<button id="tt0" class="btn mod3" style="background-color:#00af88" title="Text hinzufügen"><i class="fas fa-text-width" ></i></button>
						<button id="de0" class="btn mod4" style="background-color:#00af88" title="Elemente löschen"><i class="fas fa-trash-alt" ></i></button>
						<br>
						<button id="il0" class="btn mod5" style="background-color:#00af88" title="Bild nach links drehen"><i class="fas fa-arrow-circle-left" ></i></button>
						<button id="ir0" class="btn mod6" style="background-color:#00af88" title="Bild nach rechts drehen"><i class="fas fa-arrow-circle-right" ></i></button>
						<button id="un0" class="btn mod7" style="background-color:#00af88" title="Rückgängig"><i class="fas fa-undo" ></i></button>
						</center>
					</div>
					
				</div>
			</div>

			<div id="tool-box">	
					
				<div id="so0" class="mode1" 
					style="display: none;">
				</div>
				
				<div id="dmo0" class="mode2" style="border: 1px solid rgb(170, 170, 170); width: 512px; height: 412px; margin: 10px; padding: 5px 5px 0px 5px;  overflow: auto;  display: none;">
					<label for="drawing-mode-selector">Modus:</label> <select
						id="drawing-mode-selector0" class="mode21">
						<option>Bleistift</option>
						<option>Kreis</option>
						<option>Spray</option>
					</select> 
					<br /> <br /><br />  
					<label for="drawing-line-width">Breite:</label>
					<span class="info"></span> <input type="range" value="8"
						min="0" max="150" id="drawing-line-width0" class="mode22"></input> 
					<br /><br /> <br />  							
					<label for="drawing-color">Farbe</label> <input type="color"
						value="#ff0000" id="drawing-color0" class="mode23"></input> <br /> <br />
				</div>
				
				<div id="im0" class="mode2b" style="border: 1px solid rgb(170, 170, 170); width: 512px; height: 412px; margin: 10px; padding: 5px 5px 0px 5px; overflow: auto; display: none;">
					
					<script>
					for(var i=0; i<3; i++)
					{
						var object0 = document.createElement('p');
						var object1 = document.createElement('img');
						object1.src="../wp-content/uploads/images/icon_("+i+").svg";
						document.getElementById('im0').appendChild(object0).appendChild(object1);
					}
					</script>
					
					<!-- <c:forEach begin="0" end="1199" varStatus="loop">
						<h:graphicImage url="../wp-content/uploads/images"
							name="icon_(${loop.index}).svg" style="margin:5px;" />
					</c:forEach>-->
					
				</div>
			
				<div id="to0" class="mode3" style="border: 1px solid rgb(170, 170, 170); width: 512px; height: 412px; margin: 10px; padding: 5px 5px 0px 5px; overflow: auto; display: none;">
					<div id="text-wrapper0" class="mode31">
						<div id="text-controls">
							<div id="text-controls-row-1" >
								<div>
									<label for="font-family" style="display: inline-block">Text hinzufügen:</label>
									<button id="add-text-button0" class="btn mode32" style="background-color:#00af88"><i class="fas fa-font"></i></button>
								</div>
								</br>
								<div>
								<label for="font-family" style="display: inline-block">Font</label>
									<select id="font-family-select0" class="mode33"></select>
									<input type='checkbox' name='fonttype' id="text-cmd-bold0" class="mode34">Fett</input> 
									<input type='checkbox' name='fonttype' id="text-cmd-italic0" class="mode35">Italic</input>
								</div>
								</br>
								<div>
									<label for="text-font-size">Größe</label>
									<input type="range" value="" min="1" max="120" step="1" id="text-font-size0" class="mode36"></input>
								</div>
								</br>
								<div>
								<label for="text-color" style="display: inline-block">Textfarbe</label>
								<input type="color" value="#000000" id="text-color0" size="10" class="mode37"></input>
								
								<!-- Hintergrundfarbe ausgeblendet
								<label for="text-bg-color">Hintergrundfarbe</label> 
								<input type="color" value="" id="text-bg-color" size="10"></input>
								-->
								</div>
								
								</br>

								<!-- Kontur ausgeblendet
								<div>
									<label for="text-stroke-color">Konturfarbe</label> <input
										type="color" value="#000000" id="text-stroke-color"></input>
								</div>
								</br>
								<div>
									<label for="text-stroke-width">Konturbreite</label> <input
										type="range" value="1" min="1" max="5"
										id="text-stroke-width"></input>
								</div>
								</br>
								-->

								<div>
									<label for="text-lines-bg-color">Text-Hintergrundfarbe</label>
									<input type="color" value="#000000" id="text-lines-bg-color0"
										size="10" class="mode38"></input>
								</div>
							</div>
						</div>
					</div>
				</div>
				
				<div id="do0" class="mode4" 
					style="display: none;">
				</div>

				<div id="ilo0" class="mode5" 
					style="display: none;">
				</div>

				<div id="iro0" class="mode6" 
					style="display: none;">
				</div>

				<div id="uno0" class="mode7" 
					style="display: none;">
				</div>
			
			</div>
		</div>
		<h:outputScript library="js" name="freedrawing.js" />
    </legend>
	
	<script>

		var canvas = [];
		var canvas1 = new fabric.Canvas('c0', {
			isDrawingMode: false,
			enableRetinaScaling: false,
			imageSmoothingEnabled: false
		});
		canvas.push(canvas1);

		var activeCanvas = canvas[0];
		console.log("Active canvas (start):", activeCanvas);
		
        function handleTabChange(e) {
            var index = 0;
			if (e.childNodes[0].childNodes[0]) {
				index = parseInt(e.childNodes[0].childNodes[0].id.substring(1));
			}
			
			activeCanvas = canvas[index];
          			console.log("Active canvas (handleTabChange):", activeCanvas);
                    if(activeCanvas.freeDrawingBrush === undefined) {
                        activeCanvas.freeDrawingBrush = new fabric['Pencil' + 'Brush'](activeCanvas);
						console.log('New brush: ' + activeCanvas.freeDrawingBrush);
                    }
                    activeCanvas.freeDrawingBrush.color = document.getElementById('drawing-color'+index).value;
                    activeCanvas.freeDrawingBrush.width = parseInt(document.getElementById('drawing-line-width'+index).value, 10) || 1;
                }
(function(){
    setEventListener(0);
}())
		function setEventListener(number) {
			var $ =
				function (id) {
					return document.getElementById(id);
				};

			var canvasContainer = $('cc' + number);
			var canvasContainers = [canvasContainer];

			var fonts = ["arial black", "Helvetica", "Pacifico"];
			var fontSelect = $('font-family-select'+number);
			if(fontSelect.hasChildNodes() === false){
			fonts.forEach(function (font) {
				var option = document.createElement('option');
				option.innerHTML = font;
				option.value = font;
				fontSelect.appendChild(option);
			});
			}
			
			function isCanvasBlank(canvasElement) {
				var blank = document.createElement('canvas');
				blank.width = canvasElement.width;
				blank.height = canvasElement.height;
				return canvasElement.toDataURL() == blank.toDataURL();
			}

			
			function handleDragStart(e) {
				[].forEach.call(images, function (img) {
					img.classList.remove('img_dragging');
				});
				this.classList.add('img_dragging');
			}

			function handleDragOver(e) {
				if (e.preventDefault) {
					e.preventDefault();
				}

				e.dataTransfer.dropEffect = 'copy';
				return false;
			}

			function handleDragEnter(e) {
				this.classList.add('over');
			}

			function handleDragLeave(e) {
				this.classList.remove('over');
			}

			function handleDrop(e) {
				e.preventDefault();
				activeCanvas = canvas[number];
				
				var img = document.querySelector('#im'+number+' img.img_dragging');

				var newImage = new fabric.Image(img, {
					width: img.width,
					height: img.height,
					// Set the center of the new object based on the event coordinates
					// relative
					// to the canvas container.
					left: e.layerX,
					top: e.layerY
				});
				newImage.hasControls = newImage.hasBorders = true;
				activeCanvas.add(newImage);

				return false;
			}

			function handleDragEnd(e) {
				// this/e.target is the source node.
				[].forEach.call(images, function (img) {
					img.classList.remove('img_dragging');
				});
			}

			if (dragAndDropSupported() === true) {
				var images = document.querySelectorAll('#im'+number+' img');
				[].forEach.call(images, function (img) {
					img.addEventListener('dragstart', handleDragStart, false);
					img.addEventListener('dragend', handleDragEnd, false);
					
					// Onclick - Icons
					img.onclick = function(){
						
						activeCanvas = canvas[number];
						var newImage = new fabric.Image(img, {
							width: img.width,
							height: img.height,
							left: 225,
							top: 180
						});
						newImage.hasControls = newImage.hasBorders = true;
						activeCanvas.add(newImage);
							
					};
					//
					
				});

				[].forEach.call(canvasContainers, function (cont) {
					cont.addEventListener('dragenter', handleDragEnter, false);
					cont.addEventListener('dragover', handleDragOver, false);
					cont.addEventListener('dragleave', handleDragLeave, false);
					cont.addEventListener('drop', handleDrop, false);
				});

			} else {
				alert("Ihr Browser unterstützt leider kein 'Drag and Drop'");
			}

			function dragAndDropSupported() {
				return 'draggable' in document.createElement('span');
			}

			fabric.Object.prototype.transparentCorners = false;
			
			// SHOW Tools
			
			var selectToolButton = $('st'+number);
			console.log('Button:'+ selectToolButton);
			selectToolButton.onclick = function () {
				activeCanvas = canvas[number];
				activeCanvas.isDrawingMode = false; // No drawing mode
				$('so'+number).style.display = 'none';
				$('dmo'+number).style.display = 'none';
				$('im'+number).style.display = 'none';
				$('to'+number).style.display = 'none';
				$('do'+number).style.display = 'none';
				$('ilo'+number).style.display = 'none';
				$('iro'+number).style.display = 'none';
				$('uno'+number).style.display = 'none';
			}

			var editToolButton = $('et'+number);
			editToolButton.onclick = function () {
				activeCanvas = canvas[number];
				activeCanvas.isDrawingMode = true; // set to drawing mode
				$('so'+number).style.display = 'none';
				$('dmo'+number).style.display = 'inline-block';
				$('im'+number).style.display = 'none';
				$('to'+number).style.display = 'none';
				$('do'+number).style.display = 'none';
				$('ilo'+number).style.display = 'none';
				$('iro'+number).style.display = 'none';
				$('uno'+number).style.display = 'none';
			}

			var imagesToolButton = $('it'+number);
			imagesToolButton.onclick = function () {
				activeCanvas = canvas[number];
				activeCanvas.isDrawingMode = false; // NO drawing mode
				$('so'+number).style.display = 'none';
				$('dmo'+number).style.display = 'none';
				$('im'+number).style.display = 'inline-block';
				$('to'+number).style.display = 'none';
				$('do'+number).style.display = 'none';
				$('ilo'+number).style.display = 'none';
				$('iro'+number).style.display = 'none';
				$('uno'+number).style.display = 'none';
			}

			var textToolButton = $('tt'+number);
			textToolButton.onclick = function () {
				activeCanvas = canvas[number];
				activeCanvas.isDrawingMode = false; // NO to drawing mode
				$('so'+number).style.display = 'none';
				$('dmo'+number).style.display = 'none';
				$('im'+number).style.display = 'none';
				$('to'+number).style.display = 'inline-block';
				$('do'+number).style.display = 'none';
				$('ilo'+number).style.display = 'none';
				$('iro'+number).style.display = 'none';
				$('uno'+number).style.display = 'none';
			}

			var uploadFileButton = $('imgUpload'+number);
			
			var deleteElement = $('de'+number);
				deleteElement.onclick = function () {
				activeCanvas = canvas[number];
				
				activeCanvas.getActiveObjects().forEach((obj) => { activeCanvas.remove(obj) });
				activeCanvas.discardActiveObject().renderAll();
					
				activeCanvas.isDrawingMode = false; // NO to drawing mode
				$('so'+number).style.display = 'none';
				$('dmo'+number).style.display = 'none';
				$('im'+number).style.display = 'none';
				$('to'+number).style.display = 'none';
				$('do'+number).style.display = 'none';
				$('ilo'+number).style.display = 'none';
				$('iro'+number).style.display = 'none';
				$('uno'+number).style.display = 'none';
			}
				
			var imgleft = $('il'+number);
				imgleft.onclick = function () {
				
				activeCanvas.getActiveObjects().forEach((obj) => { (obj.rotate(obj.angle-90)) });  
				activeCanvas.renderAll();
					
				activeCanvas.isDrawingMode = false; // NO to drawing mode
				$('so'+number).style.display = 'none';
				$('dmo'+number).style.display = 'none';
				$('im'+number).style.display = 'none';
				$('to'+number).style.display = 'none';
				$('do'+number).style.display = 'none';
				$('iro'+number).style.display = 'none';
				$('uno'+number).style.display = 'none';
			}
				
			var imgright = $('ir'+number);
				imgright.onclick = function () {
				
				activeCanvas.getActiveObjects().forEach((obj) => { (obj.rotate(obj.angle+90)) });
				activeCanvas.renderAll();
					
				activeCanvas.isDrawingMode = false; // NO to drawing mode
				$('so'+number).style.display = 'none';
				$('dmo'+number).style.display = 'none';
				$('im'+number).style.display = 'none';
				$('to'+number).style.display = 'none';
				$('do'+number).style.display = 'none';
				$('ilo'+number).style.display = 'none';
				$('uno'+number).style.display = 'none';
			}
				
			var undoing = $('un'+number);
				undoing.onclick = function () {
				
				activeCanvas.undo(); 
				activeCanvas.renderAll();
					
				activeCanvas.isDrawingMode = false; // NO to drawing mode
				$('so'+number).style.display = 'none';
				$('dmo'+number).style.display = 'none';
				$('im'+number).style.display = 'none';
				$('to'+number).style.display = 'none';
				$('do'+number).style.display = 'none';
				$('ilo'+number).style.display = 'none';
			}
				
				var canvasWrapper = $('cc' + number);
				canvasWrapper.tabIndex = 1000;
				canvasWrapper.addEventListener("keydown", myfunc, false);

				function myfunc(e){
					if(e.keyCode == 8 || e.keyCode == 46) {
					activeCanvas.getActiveObjects().forEach((obj) => { activeCanvas.remove(obj) });
					activeCanvas.discardActiveObject().renderAll();
					}
				}
				
				drawingColorEl = $('drawing-color'+number),
				drawingLineWidthEl = $('drawing-line-width'+number),

				textWrapper = $('text-wrapper'+number),
				addTextButton = $('add-text-button'+number);

			// IMAGE OPTIONS
			
			uploadFileButton.onchange = function handleImage(e) {
				
				activeCanvas = canvas[number];
				
				var file = e.target.files[0];
				var fileName = file.name;
				var fileSize = file.size;
				console.log(fileName + '\n' + fileSize);
				
				// New file name as a variable with timestamp
				var formData = new FormData();
				let newfileName = new Date().getTime() + '-' + fileName;
				//fileName = newfileName;
				//e.target.files[0].name = newfileName;
				//formData.append('file[]', file, newfileName);
				
				//var element = document.GetElementById('imgUpload'+number);
				//var file = element.files[0];
				
				//var blob = file.slice(0, file.size, 'image/png'); 
				//newFile = new File([blob], 'name.png', {type: 'image/png'});
				
				console.log(fileName);
				console.log(file);
				console.log(newfileName);
				
				var reader = new FileReader();
				reader.onload = function (event) {

					if (file.size > 20971520) {
						alert("Die maximale Größe eines Bildes ist auf 20MB beschränkt. Bitte wähle ein anderes Bild aus.");
						return;
					};

					var imgObj = new Image();
					imgObj.src = event.target.result;
					//imgObj.name = newfileName;
					
					imgObj.onload = function () {
						var image = new fabric.Image(imgObj);
						
						// Bilder Drehung
						/*if( /Android|webOS|iPhone|iPad|iPod|BlackBerry|IEMobile|Opera Mini/i.test(navigator.userAgent) ) {
 							angle = 90;
						}*/
						
						/*
						
						// OLD - IMAGE
						
						var angle = 0;
						
						image.set({
							angle:angle,
							padding: 5,
							cornersize: 10
						});
						
						function getSafe(fn, defaultVal) {
						try {
								return fn();
							} 
						catch (e) {
								return defaultVal;
							}
						}

						getSafe(() => image.scaleToWidth(512));
						
						activeCanvas.centerObject(image);
						activeCanvas.add(image);
						activeCanvas.renderAll();
						
						//----------------------------
						
						*/
						
						
						// NEW - IMAGE
						
						var lanczosFilter = new fabric.Image.filters.Resize({
						  scaleX: 1,
						  scaleY: 1,
						  resizeType: 'lanczos',
						  lanczosLobes: 10,
						});
						
						var p = {
							x: 0,
							y: 0,
						};
					 
						   var r = activeCanvas.getRetinaScaling();
						   //oImg = image.set({ left: 0, top: 0}).scale(0.2);
						   
						   if(image.width > image.height){
							   oImg = image.set().scale(1/(image.width/512));
						   }
						   else{
							   oImg = image.set().scale(1/(image.height/412));
						   }
						   
						   activeCanvas.centerObject(oImg);
						
						   lanczosFilter.scaleX = lanczosFilter.scaleY = oImg.scaleX * r;
						   oImg.lockScalingFlip = true;
						   oImg.minScaleLimit = 0.025;
						   oImg.padding = 5;
						   oImg.filters = [lanczosFilter];
						   oImg.hoverCursor = 'crossHair';
						   oImg.on('scaling', function(opt) {
							   var filters = [];
							   var sX = Math.abs(this.scaleX) * r, sY = Math.abs(this.scaleY) * r;
							   if (sX > 0.01 && sY > 0.01 && sX < 1 && sY < 1) {
								   if (sX <= 0.2 || sY <= 0.2) {
									   lanczosFilter.lanczosLobes = 2;
								   } else if (sX <= 0.05 || sY <= 0.05) {
									   lanczosFilter.lanczosLobes = 1;
								   } else {
									   lanczosFilter.lanczosLobes = 3;
								   }
								   lanczosFilter.scaleX = sX;
								   lanczosFilter.scaleY = sY;
								   filters.push(lanczosFilter);
							   }
							   this.filters = filters;
						   });
						
						   oImg.on('mousedown', function(opt) {
							   if (opt.button === 3) {
								   p = oImg.getLocalPointer(opt.e);
								   p.x /= lanczosFilter.scaleX;
								   p.y /= lanczosFilter.scaleY;
								   updateFor(lanczosFilter.scaleX, lanczosFilter.scaleY)
							   }
						   })
						
						   activeCanvas.add(oImg);
						   activeCanvas.setActiveObject(oImg);
						   activeCanvas.on('before:render', function() {
						   oImg.applyFilters();
						   });
						
						// ---------------------
						
						
					};
				};
				// imgObj.src = event.target.result;
				reader.readAsDataURL(file);
			};
			
			// DRAWING OPTIONS

			if (fabric.PatternBrush) {
				var vLinePatternBrush = new fabric.PatternBrush(activeCanvas);
				vLinePatternBrush.getPatternSrc = function () {

					var patternCanvas = fabric.document.createElement('canvas');
					patternCanvas.width = patternCanvas.height = 10;
					var ctx = patternCanvas.getContext('2d');

					ctx.strokeStyle = this.color;
					ctx.lineWidth = 5;
					ctx.beginPath();
					ctx.moveTo(0, 5);
					ctx.lineTo(10, 5);
					ctx.closePath();
					ctx.stroke();

					return patternCanvas;
				};

				var hLinePatternBrush = new fabric.PatternBrush(activeCanvas);
				hLinePatternBrush.getPatternSrc = function () {

					var patternCanvas = fabric.document.createElement('canvas');
					patternCanvas.width = patternCanvas.height = 10;
					var ctx = patternCanvas.getContext('2d');

					ctx.strokeStyle = this.color;
					ctx.lineWidth = 5;
					ctx.beginPath();
					ctx.moveTo(5, 0);
					ctx.lineTo(5, 10);
					ctx.closePath();
					ctx.stroke();

					return patternCanvas;
				};

				var diamondPatternBrush = new fabric.PatternBrush(activeCanvas);
				diamondPatternBrush.getPatternSrc = function () {

					var squareWidth = 10,
						squareDistance = 5;
					var patternCanvas = fabric.document.createElement('canvas');
					var rect = new fabric.Rect({
						width: squareWidth,
						height: squareWidth,
						angle: 45,
						fill: this.color
					});

					var canvasWidth = rect.getBoundingRect().width;

					patternCanvas.width = patternCanvas.height = canvasWidth + squareDistance;
					rect.set({
						left: canvasWidth / 2,
						top: canvasWidth / 2
					});

					var ctx = patternCanvas.getContext('2d');
					rect.render(ctx);

					return patternCanvas;
				};

			}

			$('drawing-mode-selector'+number).onchange = function () {

				if (this.value === 'Bleistift') {
					var mode = "Pencil";
					activeCanvas.freeDrawingBrush = new fabric[mode + 'Brush'](activeCanvas);
				} else if (this.value === 'Spray') {
					activeCanvas.freeDrawingBrush = new fabric[this.value + 'Brush'](activeCanvas);
				} else if (this.value === 'Kreis') {
					var mode = "Pattern";
					activeCanvas.freeDrawingBrush = new fabric[mode + 'Brush'](activeCanvas);
				} else {
					var mode = "Pencil";
					activeCanvas.freeDrawingBrush = new fabric[mode + 'Brush'](activeCanvas);
				}

				if (activeCanvas.freeDrawingBrush) {
					activeCanvas.freeDrawingBrush.color = drawingColorEl.value;
					activeCanvas.freeDrawingBrush.width = parseInt(drawingLineWidthEl.value, 10) || 1;
				}
			};

			drawingColorEl.onchange = function () {
				activeCanvas.freeDrawingBrush.color = this.value;
			};

			drawingLineWidthEl.onchange = function () {
				activeCanvas.freeDrawingBrush.width = parseInt(this.value, 10) || 1;
			};


			if (activeCanvas.freeDrawingBrush) {
				activeCanvas.freeDrawingBrush.color = drawingColorEl.value;
				activeCanvas.freeDrawingBrush.width = parseInt(drawingLineWidthEl.value, 10) || 1;
			}		
			
			// TEXT OPTIONS
			
			addTextButton.onclick = function () {
				activeCanvas = canvas[number];
				activeCanvas.add(new fabric.IText('Neuer Text.', {
					left: 50,
					top: 100,
					fontFamily: 'arial black',
					fill: '#333',
					fontSize: 30
				}));
			}

			$('text-color'+number).onchange = function () {
				activeCanvas.getActiveObject().set("fill", this.value);
				activeCanvas.renderAll();
			};

			/*$('text-bg-color').onchange = function () {
				activeCanvas.getActiveObject().set("backgroundColor", this.value);
				activeCanvas.renderAll();
			};*/

			$('text-lines-bg-color'+number).onchange = function () {
				activeCanvas.getActiveObject().set("textBackgroundColor", this.value);
				activeCanvas.renderAll();
			};

			/*$('text-stroke-color').onchange = function () {
				activeCanvas.getActiveObject().set("stroke", this.value);
				activeCanvas.renderAll();
			};

			$('text-stroke-width').onchange = function () {
				activeCanvas.getActiveObject().set("strokeWidth", this.value);
				activeCanvas.renderAll();
			};*/

			$('font-family-select'+number).onchange = function () {
				activeCanvas.getActiveObject().set("fontFamily", this.value);
				activeCanvas.renderAll();
			};

			$('text-font-size'+number).onchange = function () {
				activeCanvas.getActiveObject().set("fontSize", this.value);
				activeCanvas.renderAll();
			};

			radios5 = document.getElementsByName("fonttype");
			for (var i = 0, max = radios5.length; i < max; i++) {
				radios5[i].onclick = function () {

					if ($(this.id).checked == true) {
						if (this.id == "text-cmd-bold"+number) {
							activeCanvas.getActiveObject().set("fontWeight", "bold");
						}
						if (this.id == "text-cmd-italic"+number) {
							activeCanvas.getActiveObject().set("fontStyle", "italic");
						}

					} else {
						if (this.id == "text-cmd-bold"+number) {
							activeCanvas.getActiveObject().set("fontWeight", "");
						}
						if (this.id == "text-cmd-italic"+number) {
							activeCanvas.getActiveObject().set("fontStyle", "");
						}

					}

					activeCanvas.renderAll();
				}
			}
			
		};

	</script>

<!-------------------------------------------------------------------------------------->

            </td> </tr>
        </div>

        <script>
            function createNewStep(evt) {
				
				var dupliationContent, contentTab;
                contentTab = document.getElementById('Content');
                dupliationContent = document.getElementsByClassName('duplicationContent')[0];
                console.log(dupliationContent);
				
				var newContent = dupliationContent.cloneNode(true);
				console.log(newContent);
				newContent.getElementsByTagName('textarea')[0].id = 't' + document.getElementsByClassName('duplicationContent').length + '';
				newContent.getElementsByTagName('textarea')[0].value = null;
                newContent.getElementsByTagName('canvas')[0].id = 'c' + document.getElementsByClassName('duplicationContent').length + '';
				contentTab.insertBefore(newContent, contentTab.children[contentTab.childElementCount - 2]);
				
				newContent.getElementsByTagName('canvas')[0].width = 512;
				newContent.getElementsByTagName('canvas')[0].height = 412;
				
				var canvas1 = new fabric.Canvas('c' + (document.getElementsByClassName('duplicationContent').length-1), {isDrawingMode: false, enableRetinaScaling: false, imageSmoothingEnabled: false}); 
				canvas.push(canvas1);
				canvas1.freeDrawingBrush = new fabric['Pencil' + 'Brush'](canvas1);	
				canvas1.freeDrawingBrush.color = '#ff0000';
				canvas1.freeDrawingBrush.width = 10;
				canvas1.width = 512;
				canvas1.height = 412;
				
				document.getElementsByName('step_legend')[document.getElementsByName('step_legend').length-1].innerHTML = 'Schritt ' + (document.getElementsByName('step_legend').length);
                
				document.getElementById('delStepBtn').style.display = '';
				
				document.getElementsByName('canvas-container-div')[document.getElementsByName('canvas-container-div').length-1].id = 'cc' + (document.getElementsByClassName('duplicationContent').length - 1);
				
				document.getElementsByName('canvas-container-div')[document.getElementsByName('canvas-container-div').length-1].width = 512;
				
				document.getElementsByName('canvas-container-div')[document.getElementsByName('canvas-container-div').length-1].height = 412;
				
				// ------------------------------------------------------------------------------------
			
				/*let imageUploadForm = 'imgUploadForm' + (document.getElementsByClassName('duplicationContent').length - 1);
				document.getElementsByClassName('mod00')[document.getElementsByClassName('mod00').length-1].id = imageUploadForm;*/
			
				let imageUploadInput = 'imgUpload' + (document.getElementsByClassName('duplicationContent').length - 1); 
				document.getElementsByClassName('mod01')[document.getElementsByClassName('mod01').length-1].id = imageUploadInput;
				
				// "Not"-Lösung
				document.getElementsByClassName('mod01')[document.getElementsByClassName('mod01').length-1].type = 'text';
				document.getElementsByClassName('mod01')[document.getElementsByClassName('mod01').length-1].type = 'file';
				
			//----------------------------------------------
				
				/*newContent.getElementsByTagName('h:form')[0].id = 'imgUploadForm' + document.getElementsByClassName('duplicationContent').length + '';
				newContent.getElementsByTagName('h:form')[0].value = null;
				
				newContent.getElementsByTagName('input')[0].id = 'imgUpload' + document.getElementsByClassName('duplicationContent').length + '';
				newContent.getElementsByTagName('input')[0].value = null;*/
				
				/*var imageUploadForm = document.createElement("h:form");
				imageUploadForm.setAttribute("id", 'imgUploadForm' + (document.getElementsByClassName('duplicationContent').length - 1));
				imageUploadForm.setAttribute("class", "mod00");
				imageUploadForm.setAttribute("enctype", "multipart/form-data");

				var imageUploadInputNew = document.createElement("input");
				imageUploadInputNew.setAttribute("type", "file"); 
				imageUploadInputNew.setAttribute("id", 'imgUpload' + (document.getElementsByClassName('duplicationContent').length - 1));
				imageUploadInputNew.setAttribute("class", "mod01");
				imageUploadInputNew.setAttribute("accept", "image/*");
				imageUploadForm.appendChild(imageUploadInputNew);*/

				/*$('#'+imageUploadForm).replaceWith('<h:form id="' + imageUploadForm + '" class="mod00" enctype="multipart/form-data">');

				$('#'+imageUploadInput).replaceWith('<input id="' + imageUploadInput + '" type="file" class="mod01" accept="image/*">'); /* < img ... > */
				
				// ------------------------------------------------------------------------------------
			
				// selectToolButton
				document.getElementsByClassName('mod1')[document.getElementsByClassName('mod1').length-1].id = 'st' + (document.getElementsByClassName('duplicationContent').length - 1);
				
				// editToolButton
				document.getElementsByClassName('mod2')[document.getElementsByClassName('mod2').length-1].id = 'et' + (document.getElementsByClassName('duplicationContent').length - 1);
				
				// imageToolButton
				document.getElementsByClassName('mod2b')[document.getElementsByClassName('mod2b').length-1].id = 'it' + (document.getElementsByClassName('duplicationContent').length - 1);
				
				// textToolButton
				document.getElementsByClassName('mod3')[document.getElementsByClassName('mod3').length-1].id = 'tt' + (document.getElementsByClassName('duplicationContent').length - 1);
				
				// deleteToolButton
				document.getElementsByClassName('mod4')[document.getElementsByClassName('mod4').length-1].id = 'de' + (document.getElementsByClassName('duplicationContent').length - 1);
				
				// imageleftToolButton
				document.getElementsByClassName('mod5')[document.getElementsByClassName('mod5').length-1].id = 'il' + (document.getElementsByClassName('duplicationContent').length - 1);
				
				// imagerightToolButton
				document.getElementsByClassName('mod6')[document.getElementsByClassName('mod6').length-1].id = 'ir' + (document.getElementsByClassName('duplicationContent').length - 1);
				
				// undoToolButton
				document.getElementsByClassName('mod7')[document.getElementsByClassName('mod7').length-1].id = 'un' + (document.getElementsByClassName('duplicationContent').length - 1);
				
				// ------------------------------------------------------------------------------------
				
				// selectToolBox
				document.getElementsByClassName('mode1')[document.getElementsByClassName('mode1').length-1].id = 'so' + (document.getElementsByClassName('duplicationContent').length - 1);
				
				// ------------------------------------------------------------------------------------
				
				// editToolBox
				document.getElementsByClassName('mode2')[document.getElementsByClassName('mode2').length-1].id = 'dmo' + (document.getElementsByClassName('duplicationContent').length - 1);
				
				document.getElementsByClassName('mode21')[document.getElementsByClassName('mode21').length-1].id = 'drawing-mode-selector' + (document.getElementsByClassName('duplicationContent').length - 1);
				
				document.getElementsByClassName('mode22')[document.getElementsByClassName('mode22').length-1].id = 'drawing-line-width' + (document.getElementsByClassName('duplicationContent').length - 1);
				
				document.getElementsByClassName('mode23')[document.getElementsByClassName('mode23').length-1].id = 'drawing-color' + (document.getElementsByClassName('duplicationContent').length - 1);
				
				document.getElementById('dmo'+ (document.getElementsByClassName('duplicationContent').length-1)).style.display = 'none';
				
				// ------------------------------------------------------------------------------------
				
				// imageToolBox
				document.getElementsByClassName('mode2b')[document.getElementsByClassName('mode2b').length-1].id = 'im' + (document.getElementsByClassName('duplicationContent').length - 1);
				
				document.getElementById('im'+ (document.getElementsByClassName('duplicationContent').length-1)).style.display = 'none';
				
				// ------------------------------------------------------------------------------------
				
				// textToolBox
				document.getElementsByClassName('mode3')[document.getElementsByClassName('mode3').length-1].id = 'to' + (document.getElementsByClassName('duplicationContent').length - 1);
				
				document.getElementsByClassName('mode31')[document.getElementsByClassName('mode31').length-1].id = 'text-wrapper' + (document.getElementsByClassName('duplicationContent').length - 1);
				
				document.getElementsByClassName('mode32')[document.getElementsByClassName('mode32').length-1].id = 'add-text-button' + (document.getElementsByClassName('duplicationContent').length - 1);
				
				document.getElementsByClassName('mode33')[document.getElementsByClassName('mode33').length-1].id = 'font-family-select' + (document.getElementsByClassName('duplicationContent').length - 1);				

				document.getElementsByClassName('mode34')[document.getElementsByClassName('mode34').length-1].id = 'text-cmd-bold' + (document.getElementsByClassName('duplicationContent').length - 1);
				
				document.getElementsByClassName('mode35')[document.getElementsByClassName('mode35').length-1].id = 'text-cmd-italic' + (document.getElementsByClassName('duplicationContent').length - 1);	

				document.getElementsByClassName('mode36')[document.getElementsByClassName('mode36').length-1].id = 'text-font-size' + (document.getElementsByClassName('duplicationContent').length - 1);
				
				document.getElementsByClassName('mode37')[document.getElementsByClassName('mode37').length-1].id = 'text-color' + (document.getElementsByClassName('duplicationContent').length - 1);	

				document.getElementsByClassName('mode38')[document.getElementsByClassName('mode38').length-1].id = 'text-lines-bg-color' + (document.getElementsByClassName('duplicationContent').length - 1);
				
				document.getElementById('to'+ (document.getElementsByClassName('duplicationContent').length-1)).style.display = 'none';
				
				// ------------------------------------------------------------------------------------
				
				// deleteToolBox 
				document.getElementsByClassName('mode4')[document.getElementsByClassName('mode4').length-1].id = 'do' + (document.getElementsByClassName('duplicationContent').length - 1);
				
				// ------------------------------------------------------------------------------------
				
				// imageleftToolBox
				document.getElementsByClassName('mode5')[document.getElementsByClassName('mode5').length-1].id = 'ilo' + (document.getElementsByClassName('duplicationContent').length - 1);
				
				// ------------------------------------------------------------------------------------

				// imagerightToolBox
				document.getElementsByClassName('mode6')[document.getElementsByClassName('mode6').length-1].id = 'iro' + (document.getElementsByClassName('duplicationContent').length - 1);
				
				// ------------------------------------------------------------------------------------
				
				// undoToolBox
				document.getElementsByClassName('mode7')[document.getElementsByClassName('mode7').length-1].id = 'uno' + (document.getElementsByClassName('duplicationContent').length - 1);
				
				// ------------------------------------------------------------------------------------
				
				var e = document.getElementsByName('canvas-container-div')[document.getElementsByName('canvas-container-div').length-1];
				var child = e.childNodes[1].childNodes[0];
				e.prepend(child);
				var rem = document.getElementsByClassName("canvas-container")[document.getElementsByClassName("canvas-container").length-1];
				console.log(rem);
				rem.parentNode.removeChild(rem);
				setEventListener(document.getElementsByClassName('duplicationContent').length-1);
				
				// ------------------------------------------------------------------------------------
				
				console.log('so'+ (document.getElementsByClassName('duplicationContent').length-1));

				datamatomounmask();
				
			}
			
			// ------------------------------------------------------------------------------------
  
			function removeStep(evt) {
                // 1) get all divs of class duplicationContent
                // 2) get last element of those
                // 3) remove it
                // 4) Exception: Don't remove last element
                var noDivs = document.getElementsByClassName('duplicationContent').length;
                var lastDuplicate = document.getElementsByClassName('duplicationContent')[noDivs - 1];
                if (noDivs > 1)
                    lastDuplicate.parentNode.removeChild(lastDuplicate);
                if (document.getElementsByClassName('duplicationContent').length == 1)
                    document.getElementById('delStepBtn').style.display = 'none';
				canvas.pop();
            }
			
			function submittitle() {
				//alert('test');
				document.getElementById('title-original').value = document.getElementById('title_fake1').value;
			}
			
        </script>

		<div id="addStepBox">
			<legend id="addStepBtnText" style="font-style: italic; /*height:150px;*/ display: flex;
  flex-direction: column;" class="explaintextbox" >
			C) Fügen Sie einen weiteren notwendigen Arbeitsschritt hinzu, entfernen Sie (bei 2 oder mehr angelegten Beschreibungen) einen Prozessschritt oder fahren Sie mit der Kontrolle und Speicherung Ihrer Eingaben fort, indem Sie auf "3. Zusammenfassung" klicken. 
			</legend>
			<br /><br />
			<button id="addStepBtn" onclick="createNewStep(event)" class="btn" style="background-color:#00af88;"
					title="Add new step">
				Hinzufügen
			</button>
			<button id="delStepBtn" onclick="removeStep(event)" class="btn" style="background-color:#00af88; display: none;"
					title="Remove step">
				Entfernen
			</button>
		</div>

    </div>

    <!------------------------------------- POSTING 3. CHECK ------------------------------------->

    <div id="Check" class="tabcontent">
	
		<br /><legend class="explaintextbox" style="font-style: italic;">Überprüfen Sie Ihre Eingaben.</legend>
		
		<?php echo '<tr><td class="frontier_no_border"><br />';
        #var_dump($tax_form_lists["category"]);

        foreach ($tax_layout_list as $tmp_tax_name => $tmp_tax_layout) {
            if ($tmp_tax_layout != "hide") {
                // Cats_selected is set from script, but only for category
                if ($tmp_tax_name != 'category')
                    $cats_selected = wp_get_post_terms($thispost->ID, '$tmp_tax_name', array("fields" => "ids"));

                echo '<fieldset class="frontier_post_fieldset_tax frontier_post_fieldset_tax_' . $tmp_tax_name . '">';
                echo '<legend class="frontier_post_legend_tax" >' . $titles->sops . '</legend>';

                do_action('frontier_post_form_standard_tax', $thispost, $tmp_task_new, $tmp_tax_name);
                frontier_tax_input($thispost->ID, 'category_2', $tmp_tax_layout, $cats_selected, $fpost_sc_parms, $sops);
				echo "<script type='text/javascript'>
				var sl2 = document.querySelector('#fp_tax_category_2');
				sl2.onchange = function() {
					var stepDropDown1 = document.getElementById('fp_tax_step_1');
					var stepDropDown2 = document.getElementById('fp_tax_step_2');
					var sopId = sl2.options[sl2.selectedIndex].value;
					var noSteps = stepDropDown1.options.length; 
					for (var i = 0; i < noSteps; i++) {
						stepDropDown1.options[0] = null;
						stepDropDown2.options[0] = null;
					}
					Object.keys(allSteps[sopId]).forEach(function(k){
						var option = document.createElement('option');
						option.text = allSteps[sopId][k];
						option.classList.add('fp_multi');
						<!-- option.classList.add('fp_dropdown'); -->
						option.value = k;
						var option2 = option.cloneNode(true);
						stepDropDown1.add(option);
						stepDropDown2.add(option2);
					});
					syncList(2);
	    		}
				</script>";
				echo '</fieldset>';
                echo PHP_EOL;
            }
        } ?>
		
		<!-----------------------  ---------------------->
		
		<?php echo '<tr><td class="frontier_no_border">';
        #var_dump($tax_form_lists["category"]);

        foreach ($tax_layout_list as $tmp_tax_name => $tmp_tax_layout) {
            if ($tmp_tax_layout != "hide") {
                // Cats_selected is set from script, but only for category
                if ($tmp_tax_name != 'category')
                    $cats_selected = wp_get_post_terms($thispost->ID, '$tmp_tax_name', array("fields" => "ids"));
				
				echo '<fieldset class="frontier_post_fieldset_tax frontier_post_fieldset_tax_' . $tmp_tax_name . '">';
                echo '<legend class="frontier_post_legend_tax" >' . $titles->steps . '</legend>';

                do_action('frontier_post_form_standard_tax', $thispost, $tmp_task_new, $tmp_tax_name);
                frontier_tax_input($thispost->ID, 'step_2', $tmp_tax_layout, $cats_selected, $fpost_sc_parms, $steps[$loadedSopId]);
				echo "<script type='text/javascript'>
				var sl4 = document.querySelector('#fp_tax_step_2');
				sl4.onchange = function() {syncList(4)};
				</script>";
                echo '</fieldset>';
                echo PHP_EOL;
            }
        } ?>
		
		<!------------------------------------------------------------------------>
		
		<!-- <fieldset class="frontier_post_fieldset_tax frontier_post_fieldset_tax_category">
			<legend class="frontier_post_legend_tax"><?php if (isset($titles->categories)) {echo $titles->categories;} else {echo '';}?></legend>
			<select class="frontier_post_dropdown category-input" name="fp_tax_category[]" id="fp_tax_category" multiple="multiple" size="10"></select>		
		</fieldset> -->
		
			<script>
			function syncList(num) { 
				
				selectListe1 = document.querySelector('#fp_tax_category_1');
				selectListe2 = document.querySelector('#fp_tax_category_2');
				selectListe3 = document.querySelector('#fp_tax_step_1'); 
				selectListe4 = document.querySelector('#fp_tax_step_2');
				selectListe5 = document.querySelector('#fp_tax_type_1'); 
				selectListe6 = document.querySelector('#fp_tax_type_2');
				
				//selectListe1 = document.getElementById('fp_tax_category_1');
				//selectListe2 = document.getElementById('fp_tax_category_2');
				//selectListe3 = document.getElementById('fp_tax_step_1'); 
				//selectListe4 = document.getElementById('fp_tax_step_2');
				//selectListe5 = document.getElementById('fp_tax_type_1'); 
				//selectListe6 = document.getElementById('fp_tax_type_2');

				if(num == 1)
				{
					selectListe2.selectedIndex = selectListe1.selectedIndex;
					//selectListe2.value = selectListe1.value;
				}

				if(num == 2)
				{
					selectListe1.selectedIndex = selectListe2.selectedIndex;
					//selectListe1.value = selectListe2.value;
				}
				
				if(num == 3)
				{
					selectListe4.selectedIndex = selectListe3.selectedIndex;
					//selectListe4.value = selectListe3.value;
				}
				
				if(num == 4)
				{
					selectListe3.selectedIndex = selectListe4.selectedIndex;
					//selectListe3.value = selectListe4.value;
				}
				
				if(num == 5)
				{
					selectListe6.selectedIndex = selectListe5.selectedIndex;
					//selectListe6.value = selectListe5.value;
				}
				
				if(num == 6)
				{
					selectListe5.selectedIndex = selectListe6.selectedIndex;
					//selectListe5.value = selectListe6.value;
				}
					
				selectCategories = document.querySelector('#fp_tax_category');
				selectCategories.innerHTML = '';
				
				var option = document.createElement('option');
        		option.classList.add('fp_multi');
        		//option.classList.add('fp_dropdown');
				option.text = 'dummy';
				if (selectListe2.selectedIndex > -1) {
					option.value = selectListe2[selectListe2.selectedIndex].value;
					option.selected = true;
					selectCategories.appendChild(option);
				}
				
				var option = document.createElement('option');
        		option.classList.add('fp_multi');
				//option.classList.add('fp_dropdown');
				option.text = 'dummy';
				if (selectListe4.selectedIndex > -1) {
					option.value = selectListe4[selectListe4.selectedIndex].value;
					option.selected = true;
					selectCategories.appendChild(option);
				}
				
				var option = document.createElement('option');
        		option.classList.add('fp_multi');
        		//option.classList.add('fp_dropdown');
				option.text = 'dummy';
				if (selectListe6.selectedIndex > -1) {
					option.value = selectListe6[selectListe6.selectedIndex].value;
					option.selected = true;
					selectCategories.appendChild(option);  
        		}
			}
			</script>
		
		<?php echo '<tr><td class="frontier_no_border">';
        #var_dump($tax_form_lists["category"]);

        foreach ($tax_layout_list as $tmp_tax_name => $tmp_tax_layout) {
            if ($tmp_tax_layout != "hide") {
                // Cats_selected is set from script, but only for category
                if ($tmp_tax_name != 'category')
                    $cats_selected = wp_get_post_terms($thispost->ID, '$tmp_tax_name', array("fields" => "ids"));

                echo '<fieldset class="frontier_post_fieldset_tax frontier_post_fieldset_tax_' . $tmp_tax_name . '">';
                echo '<legend class="frontier_post_legend_tax" >' . $titles->types . '</legend>';

                do_action('frontier_post_form_standard_tax', $thispost, $tmp_task_new, $tmp_tax_name);
                frontier_tax_input($thispost->ID, 'type_2', $tmp_tax_layout, $cats_selected, $fpost_sc_parms, $beitragstypen);
				echo "<script type='text/javascript'>
					var sl6 = document.getElementById('fp_tax_type_2');
					sl6.onchange = function() {
						syncList(6);
				}
				</script>";
                
                echo '</fieldset>';
                echo PHP_EOL;
            }
        }?>
		
  <!-- multiple entfernen -> normaler Select -->
  <!-- <select class="frontier_post_dropdown" name="fp_tax_category[]" id="fp_tax_category" multiple style="display: none">
  </select> -->
		
  <select class="frontier_post_dropdown" name="fp_tax_category[]" id="fp_tax_category" multiple style="display: none">
  </select>	
		
		<!-- <fieldset class="frontier_post_fieldset_tax frontier_post_fieldset_tax_category">
			<legend class="frontier_post_legend_tax"><?php echo $titles->types; ?></legend>
			<select class="frontier_post_dropdown types-input" name="fp_tax_category[]" id="fp_tax_category" multiple="multiple" size="10"></select>		
		</fieldset> -->
		
			<script>
				var $inputtype = $(".types-input");
				$inputtype.keyup(function() {
					$inputtype.val($(this).val());
				});
				$inputtype.on( "paste keyup", function() { 
					$inputtype.val($(this).val() );
				});	
			</script>
		
			<fieldset id="frontier_post_fieldset_title_fake2" class="frontier_post_fieldset">
				<legend><?php echo $titles->title; ?></legend>
				<input id="title_fake2" class="frontier-formtitle title-input" type="text" value="<?php if (!empty($thispost->post_title)) echo $thispost->post_title; ?>">
			</fieldset>

			<script>
				var $inputtitle = $(".title-input");
				$inputtitle.keyup(function() {
					$inputtitle.val($(this).val());
				});
				$inputtitle.on( "paste keyup", function() { 
					$inputtitle.val($(this).val() );
				});	
			</script>
		
		    <tr>
                <td class="frontier_no_border">
                    <fieldset class="frontier_post_fieldset">
						<legend></legend><br>
                        <legend><?php echo $titles->content; ?></legend>
                    </fieldset>
                </td>
            </tr>
		
		
		            <?php

            //****************************************************************************************************
            // post moderation
            //****************************************************************************************************

            if (fp_get_option_bool("fps_use_moderation") && (current_user_can("edit_others_posts") || $current_user->ID == $thispost->post_author)) {
                echo '<tr><td class="frontier_no_border">';
                echo '<fieldset class="frontier_post_fieldset_moderation">';
                echo '<legend>' . __("Post Moderation", "frontier-post") . '</legend>';
                //Allow email to be send to author on comment update
                if (current_user_can("edit_others_posts"))
                    echo __("Email author with moderation comments ?", "frontier-post") . ' ' . '<input name="frontier_post_moderation_send_email" id="frontier_post_moderation_send_email" value="true"  type="checkbox"><br>';

                echo '<textarea name="frontier_post_moderation_new_text" id="frontier_post_moderation_new_text" >';
                echo '</textarea>';
                echo __("Previous comments", "frontier-post") . ':<br>';
                echo '<hr>';
                echo $fp_moderation_comments;

                echo '</fieldset>';


                echo '</td></tr>';

            }
            //****************************************************************************************************
            // Action fires just before the submit buttons
            // Do action 		frontier_post_form_standard
            // $thispost 		Post object for the post
            // $tmp_task_new  	Equals true if the user is adding a post
            //****************************************************************************************************

            do_action('frontier_post_form_standard', $thispost, $tmp_task_new);

            ?>

            <div id="frontierpost">
                <?php
                wp_editor($thispost->post_content, 'frontier_post_content', frontier_post_wp_editor_args(100));
                //wp_editor($thispost->post_content, 'user_post_desc', array());

                ?>
            </div>

            <p>&nbsp </p>
		
        <tr>
            <td>
				
                <fieldset class="frontier_post_fieldset">
                    <legend><?php _e("Einreichung des Beitrags:", "frontier-post"); ?></legend>
				</fieldset>
				
					<legend class="explaintextbox" style="font-style: italic;">Sind alle Ihre Eingaben korrekt, klicken Sie auf „Speichern & Vorschau“ um den neuen Lerninhalt für die Bearbeitung durch Ihren Vorgesetzten freizugeben. </legend><br>
				
					<fieldset class="frontier_post_fieldset">
                    <?php

                    if (fp_get_option_bool("fps_submit_save")) { ?>
                        <button class="button" type="submit" name="user_post_submit" id="user_post_save"
                                value="save" onclick='submittitle();'><?php _e("Save", "frontier-post"); ?></button>
                    <?php }

                    if (fp_get_option_bool("fps_submit_savereturn")) { ?>
                        <button class="button" type="submit" name="user_post_submit" id="user_post_submit"
                                value="savereturn" onclick='submittitle();'><?php echo $fpost_sc_parms['frontier_return_text']; ?></button>
                    <?php }

                    if (fp_get_option_bool("fps_submit_publish") && ($thispost->post_status !== "publish" || $tmp_task_new) && current_user_can("frontier_post_can_publish")) { ?>
                        <button class="button" type="submit" name="user_post_submit" id="user_post_publish"
                                value="publish" onclick='submittitle();'><?php _e("Veröffentlichen", "frontier-post"); ?></button>
                    <?php }

                    if (fp_get_option_bool("fps_submit_preview")) { ?>
                        <button class="button" type="submit" name="user_post_submit" id="user_post_preview"
                                value="preview" onclick='submittitle();'><?php _e("Save & Preview", "frontier-post") ?></button>
                    <?php }

                    if (fp_get_option_bool("fps_submit_delete") && current_user_can("frontier_post_can_delete") && !$tmp_task_new) { ?>
                        <button class="button frontier-post-form-delete" type="submit" name="user_post_submit"
                                id="user_post_delete" value="delete"><?php _e("Delete", "frontier-post"); ?></button>
                    <?php }

                    if (fp_get_option_bool("fps_submit_cancel")) { ?>
                        <input type="reset" value="<?php _e("Cancel", "frontier-post"); ?>" name="cancel"
                               id="frontier-post-cancel" onclick="location.href='<?php the_permalink(); ?>'">
                    <?php }

                    /*
                    if ( fp_get_option_bool("fps_submit_delete") && $thispost->post_status !== "publish" && current_user_can("frontier_post_can_delete") && !$tmp_task_new )
                        {
                        echo "&nbsp;".frontier_post_delete_link($thispost, false, $frontier_permalink, 'frontier-post-form-delete' );
                        }
                    */
					
                    echo '<p class="frontier-post-form-posttype">&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;(' . __("Post type", "frontier-post") . ": " . fp_get_posttype_label_singular($thispost->post_type) . ') </p>';
                    ?>
					
                </fieldset>
				
				<br />
					<legend class="explaintextbox" style="font-style: italic;">
Vielen Dank für Ihre Mithilfe. Ihre Unterstützung leistet einen wichtigen Beitrag zum reibungslosen Ablauf in unseren Produktionsbereichen!
</legend><br /><br />
				
            </td>
        </tr>
    </div>

<div id="tabs2" class="tab">
	 <button id= "topic2" class="tablinks" onclick="openTabs(event, 'Topic')" id="defaultOpenTab" style="font-size:16px">1. Thema</button>
     <button id= "content2" class="tablinks" onclick="openTabs(event, 'Content'); copytocontent();" style="font-size:16px">2. Inhalt</button>
    <button id= "check2" class="tablinks" onclick="openTabs(event, 'Check'); copytowpeditor();" style="font-size:16px">3. Zusammenfassung</button>
</div>

    </form>

    </div> <!-- ending div -->
    </div>
<?php
// end form file
?>