<?php
/*
Utilities for Frontier Post plugin
*/


//********************************************************************************
// Standard html field output support functions
//********************************************************************************


function fq_build_html_field($type, $field_name, $values, $selected = array(), $all_option = false, $field_id = '')
	{
	
	// If field id = '', set as name
	if ($field_id === '')
		$field_id = $field_name;
		
	//$field_name = fq_field_name($field_name);
	switch ($type)
		{
		case 'checkbox':
			return  fq_build_checkbox_html($field_name, $values, $selected , $all_option, $field_id);
		
		case 'checkboxline':
			return  fq_build_checkboxline_html($field_name, $values, $selected , $all_option, $field_id);
		
		case 'radio':
			return  fq_build_radio_html($field_name, $values, $selected , $all_option, $field_id);
			
		case 'radioline':
			return  fq_build_radioline_html($field_name, $values, $selected , $all_option, $field_id);
		
		case 'dropdown':
			return  fq_build_dropdown_html($field_name, $values, $selected , $all_option, $field_id);
		
		case 'multi':
			return  fq_build_multi_html($field_name, $values, $selected , $all_option, $field_id);
		
		case 'text':
			return  fq_build_textinput_html($field_name, $selected , $field_id);
		
		default:
			return 'wrong type - fq_build_html_field()';
		}
	}


function fq_build_checkbox_html($field_name, $values, $selected = array(), $all_option = false, $field_id)
	{
	$tmp_html = '';
	if (!is_array($selected))
		$selected = array($selected);	
	
	if ($all_option)
		$values = array_merge(array(0 => __('Alle', 'frontier-query')), $values);
	
	foreach ( $values as $key => $value) :
		$tmp_html .= '<input class="frontier-query-checkbox" type="checkbox" ';
		$tmp_html .= ' name="'.$field_name.'[]" id="'.$field_id.'"';	
		$tmp_html .= ' value="'.$key.'"'; 
		if ( in_array( $key, $selected ) ) 
			$tmp_html .= 'checked="checked"'; 
		$tmp_html .= '>'.$value.'<br>'.PHP_EOL;
		endforeach;
	return $tmp_html;	
	
	}

function fq_build_checkboxline_html($field_name, $values, $selected = array(), $all_option = false, $field_id)
	{
	$tmp_html = '';
	if (!is_array($selected))
		$selected = array($selected);	
	
	if ($all_option)
		$values = array_merge(array(0 => __('Alle', 'frontier-query')), $values);
	
	foreach ( $values as $key => $value) :
		$tmp_html .= '<input class="frontier-query-checkbox" type="checkbox" ';
		$tmp_html .= ' name="'.$field_name.'[]" id="'.$field_id.'"';	
		$tmp_html .= ' value="'.$key.'"'; 
		if ( in_array( $key, $selected ) ) 
			$tmp_html .= 'checked="checked"'; 
		$tmp_html .= '>'.$value.''.PHP_EOL;
		endforeach;
	return $tmp_html;	
	
	}



function fq_build_radio_html($field_name, $values, $selected = array(), $all_option = false, $field_id)
	{
	$tmp_html = '';
	if (!is_array($selected))
		$selected = array($selected);	
	
	if ($all_option)
		$values = array(0 => __('Alle', 'frontier-query'))+$values;
	
	foreach ( $values as $key => $value) :
		$tmp_html .= '<input class="frontier-query-radio" type="radio" ';
		$tmp_html .= ' name="'.$field_name.'" id="'.$field_id.'"';	
		$tmp_html .= ' value="'.$key.'"'; 
		if ( in_array( $key, $selected ) ) 
			$tmp_html .= 'checked="checked"'; 
		$tmp_html .= '>'.$value.'<br>'.PHP_EOL;
		endforeach;
	return $tmp_html;	
	
	}

function fq_build_radioline_html($field_name, $values, $selected = array(), $all_option = false, $field_id)
	{
	$tmp_html = '';
	if (!is_array($selected))
		$selected = array($selected);	
	
	if ($all_option)
		$values = array(0 => __('Alle', 'frontier-query'))+$values;
	
	foreach ( $values as $key => $value) :
		$tmp_html .= '<input class="frontier-query-radioline" type="radio" ';
		$tmp_html .= ' name="'.$field_name.'" id="'.$field_id.'"';	
		$tmp_html .= ' value="'.$key.'"'; 
		if ( in_array( $key, $selected ) ) 
			$tmp_html .= 'checked="checked"'; 
		$tmp_html .= '>'.$value.'&nbsp'.PHP_EOL;
	endforeach;
	return $tmp_html;	
	
	}

	
function fq_build_dropdown_html($field_name, $values, $selected = 0, $all_option = false, $field_id)
	{
	$tmp_html = '';
	if (!is_array($selected))
		$selected = array($selected);
	
	if ($all_option)
		$values = array(0 => __('Alle', 'frontier-query'))+$values;
	
	$tmp_html .= '<select class="frontier-query-dropdown" name="'.$field_name.'" id="'.$field_id.'">';
	//error_log("Field: ".$field_name."  values --->");
	//error_log(print_r($values,true));
	foreach ( $values as $key => $value) :
		$tmp_html .= '<option value="'.$key.'"'; 
		if ( in_array( $key, $selected ) ) 
			$tmp_html .= 'selected="selected"'; 
		$tmp_html .= '>'.$value.'</option>'.PHP_EOL;
	endforeach;
	$tmp_html .= '</select>';
	return $tmp_html;	
	}

function fq_build_multi_html($field_name, $values, $selected = 0, $all_option = false, $field_id)
	{
	$tmp_html = '';
	if (!is_array($selected))
		$selected = array($selected);
	
	if ($all_option)
		$values = array(0 => __('Alle', 'frontier-query'))+$values;
	
	$tmp_html .= '<select class="frontier-query-multi" name="'.$field_name.'[]" id="'.$field_id.'" ';
	$tmp_html .= ' multiple="multiple" size="'.fq_multiple_field_size().'">';
	//$tmp_html .= ' multiple="multiple" >';
	foreach ( $values as $key => $value) :
		$tmp_html .= '<option value="'.$key.'"'; 
		if ( in_array( $key, $selected ) ) 
			$tmp_html .= 'selected="selected"'; 
		$tmp_html .= '>'.$value.'</option>'.PHP_EOL;
	endforeach;
	$tmp_html .= '</select>';
	return $tmp_html;	
	}

function fq_build_textinput_html($field_name, $selected = '', $field_id)
	{
	return '<input type="text" class="frontier-query-text" name="'.$field_name.'" id="'.$field_id.'" value="'.$selected.'">';
	}
	
// generates html output for checkbox field
function fq_text_field_html($tmp_name, $tmp_current_value, $tmp_size = 0)
	{
	if ( $tmp_size > 0 )
		 $tmp_size_txt = ' size="100" ';
	else	 
		 $tmp_size_txt = '';
	
	//error_log("Name: ".$tmp_name." - Current value: ".$tmp_current_value);
	$tmp_html = '<input type="text" name="'.$tmp_name.'" id="'.$tmp_name.'" value="'.$tmp_current_value.'" '.$tmp_size_txt.'>';
	//error_log("html: ".$tmp_html);
	return $tmp_html;
	}

// generates html output for checkbox field
function fq_checkbox_single_html($tmp_name, $tmp_current_value)
	{
	$tmp_html = '<input type="checkbox" name="'.$tmp_name.'" id="'.$tmp_name.'"  value="true"';
	if  ( $tmp_current_value == "true" )
		$tmp_html = $tmp_html.' checked >';
	else	
		$tmp_html = $tmp_html.'>';
	
	return $tmp_html;
	}
/*
function fq_build_checkbox_html($field_name, $values, $selected = 0)
	{
	$tmp_html = '';
	foreach ( $values as $key => $value) :
		$tmp_html .= '<input type="checkbox" ';
		$tmp_html .= ' name="'.$field_name.'"';	
		$tmp_html .= ' value="'.$key.'"'; 
		if ( in_array( $key, $selected ) ) 
			{ 
			$tmp_html .= 'checked="checked"'; 
			}
		$tmp_html .= '>'.$value.'<br>'.PHP_EOL;
		endforeach;
	return $tmp_html;		
	}
// generates html output for checkbox field
function fq_checkbox_field($tmp_name, $tmp_current_value)
	{
	$tmp_html = '<input type="checkbox" name="'.$tmp_name.'" id="'.$tmp_name.'"  value="true"';
	if  ( $tmp_current_value == "true" )
		$tmp_html = $tmp_html.' checked >';
	else	
		$tmp_html = $tmp_html.'>';
	
	return $tmp_html;
	}

// generates html output for checkbox field
function fq_text_field($tmp_name, $tmp_current_value, $tmp_size = 0)
	{
	if ( $tmp_size > 0 )
		 $tmp_size_txt = ' size="100" ';
	else	 
		 $tmp_size_txt = '';
	
	//error_log("Name: ".$tmp_name." - Current value: ".$tmp_current_value);
	$tmp_html = '<input type="text" name="'.$tmp_name.'" id="'.$tmp_name.'" value="'.$tmp_current_value.'" '.$tmp_size_txt.'>';
	//error_log("html: ".$tmp_html);
	return $tmp_html;
	}


*/	
	



//********************************************************************************
// Out messages
//********************************************************************************


function fq_set_msg($tmp_msg)
	{
	if ( ( isset($_REQUEST['frontier-post-msg']) ? $_REQUEST['frontier-post-msg'] : '' ) != '' )
		$_REQUEST['frontier-post-msg'] = $_REQUEST['frontier-post-msg']."<br>".$tmp_msg;
	else
		$_REQUEST['frontier-post-msg'] = $tmp_msg;
	}

function fq_output_msg()
	{
	if ( get_option("fq_show_msg", "false") == "true" )
		{
		$tmp_msg = isset($_REQUEST['frontier-post-msg']) ? $_REQUEST['frontier-post-msg'] : '';
		echo '<div class="fq_msg">'.$tmp_msg.'</div>';
		}
	$_REQUEST['frontier-post-msg'] = null;
	}
	
	


//********************************************************************************
// 
//********************************************************************************

?>